<template>
  <div>
    <h1>MAP COMPONENT</h1>
    <v-card class="ma-2 pa-2" color="light-blue darken-4">
      <h1 v-if="itemShow.id">Ruta: {{ itemShow.name }}</h1>
      <v-btn
        class="my-2"
        color="primary lighten-2"
        dark
        @click="dialogViewRuta = true"
      >
        Ver rutas
      </v-btn>
      <br />
      <h3>
        Estado:
        {{
          itemShow.id
            ? "Viendo ruta"
            : trackingPosition
            ? "Grabando"
            : pausedPosition
            ? "Pausado"
            : "Sin Iniciar"
        }}
      </h3>
      <h3>
        Tiempo:
        {{ secondsToHours() }}
      </h3>
      <v-row>
        <button ref="btnStartTracking">
          <v-btn color="red lighten-2" dark>
            {{ trackingPosition ? "Puasar" : "Iniciar" }}
          </v-btn>
        </button>
        <v-spacer></v-spacer>
        <button ref="btnStopTracking">
          <v-btn color="red lighten-2" dark>
            {{ itemShow.id ? "Limpiar" : "Parar" }}
          </v-btn>
        </button>
      </v-row>
    </v-card>
    <p></p>
    <div id="map-cont">
      <div id="map"></div>
    </div>

    <v-dialog persistent v-model="dialogSaveRecord" width="500">
      <v-card>
        <v-card-title class="text-h5 grey lighten-2">
          Guardar esta ruta
        </v-card-title>
        <v-card-text>
          <v-row>
            <v-col cols="12" sm="6" md="3">
              <v-text-field
                label="Nombre"
                placeholder="Nombre"
                outlined
                v-model="rutaNombre"
              ></v-text-field>
            </v-col>
          </v-row>
        </v-card-text>

        <v-divider></v-divider>

        <v-card-actions>
          <v-btn color="primary" text @click="dialogSaveRecord = false">
            Cancelar
          </v-btn>
          <v-spacer></v-spacer>
          <v-btn color="primary" text @click="saveRecord"> Aceptar </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-dialog persistent v-model="dialogViewRuta" width="500">
      <v-card flat tile height="500px" class="px-1">
        <v-card-title class="text-h5 grey lighten-2">
          Rutas
          <v-icon icon="mdi-home" color="black" />
        </v-card-title>
        <v-row dense class="d-flex py-2">
          <v-col cols="4">Nombre</v-col>
          <v-col cols="2">Placa</v-col>
          <v-col cols="1"></v-col>
          <v-col cols="4">Opciones</v-col>
        </v-row>
        <v-card tile flat height="400px" style="overflow-y: auto">
          <template v-for="ruta in rutas" :key="ruta.id">
            <v-row dense class="d-flex py-2 align-center">
              <v-col cols="4" class="text-caption">
                <h4>{{ ruta.name }}</h4>
              </v-col>
              <v-col cols="2" class="text-caption">
                <h4>{{ ruta.placa }}</h4>
              </v-col>
              <v-col cols="2" class="text-caption">
                <v-btn
                  class="text-caption"
                  color="primary"
                  x-small
                  text
                  @click="viewRuta(ruta)"
                >
                  Ver
                </v-btn>
              </v-col>
              <v-col cols="1"></v-col>
              <v-col cols="2">
                <v-btn
                  class="text-caption"
                  color="red lighten-2"
                  dark
                  x-small
                  text
                  @click="deleteItemLocalStorageDBRutas(ruta)"
                >
                  Borrar
                </v-btn>
              </v-col>
            </v-row>
          </template>
        </v-card>

        <v-divider></v-divider>

        <v-card-actions>
          <v-btn color="primary" text @click="dialogViewRuta = false">
            Cancelar
          </v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-dialog persistent v-model="dialogStartRecord" width="500">
      <v-card>
        <v-card-title class="text-h5 grey lighten-2">
          Iniciar nueva ruta
        </v-card-title>
        <v-card-text>
          <v-row>
            <v-col cols="12" sm="6" md="3">
              <v-text-field
                label="Placa"
                placeholder="Placa"
                outlined
                v-model="newRuta.placa"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="3">
              <v-text-field
                label="Kilometraje"
                placeholder="Kilometraje"
                outlined
                v-model="newRuta.kilometraje"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="3">
              <v-text-field
                label="Tecnico"
                placeholder="Tecnico"
                outlined
                v-model="newRuta.tecnico"
              ></v-text-field>
            </v-col>
          </v-row>
        </v-card-text>

        <v-divider></v-divider>

        <v-card-actions>
          <v-btn color="primary" text @click="dialogStartRecord = false">
            Cancelar
          </v-btn>
          <v-spacer></v-spacer>
          <v-btn color="primary" text @click="startRecord"> Iniciar </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import mapboxgl from "mapbox-gl";
import { v4 as uuidv4 } from "uuid";

export default {
  name: "MapCustom",
  data: () => ({
    localDBNameRutas: "dbRutas",
    dialogViewRuta: false,
    dialogSaveRecord: false,
    dialogStartRecord: false,
    map: null,
    newRuta: {
      placa: "",
      kilometraje: "",
      tecnico: "",
    },
    rutaNombre: "",
    accessToken:
      "pk.eyJ1IjoiZGllZ29leHBhbnNpb24iLCJhIjoiY2w4dnF2bngwMGdobDN2bzhibHl5YzlwbyJ9.OuGTaxTKzyag57iMZAQd-A",
    coordsInterval: null,
    timerInterval: null,
    seconds: 0,
    showingRuta: false,
    trackingPosition: false,
    pausedPosition: false,
    watchID: null,
    mapObject: null,
    centerPosition: {
      lat: 10.762622,
      lng: 106.660172,
    },
    zoom: 16,
    positions: [],
    rutas: [],
    itemShow: {},
    currentPositionMarker: null,
    geojson: {
      type: "Feature",
      properties: {},
      geometry: {
        type: "LineString",
        coordinates: [
          // [-75.29834, 2.9498336],
          // [-75.29874, 2.9498376]
        ],
      },
    },
  }),
  props: {
    msg: String,
  },
  mounted() {
    navigator.geolocation.getCurrentPosition(
      this.initMap,
      this.failurePosition,
      {
        enableHighAccuracy: true,
      }
    );
    this.listLocalStorageDBRutas();
  },
  watch: {
    showingRuta(value) {
      if (!value) {
        this.itemShow = {};
      }
    },
  },
  methods: {
    secondsToHours() {
      let sconds = this.itemShow.id
        ? Number(this.itemShow.seconds)
        : this.seconds;
      const result = new Date(sconds * 1000).toISOString().slice(11, 19);
      return result;
    },
    listLocalStorageDBRutas() {
      let rutas = [];
      if (localStorage.getItem(this.localDBNameRutas)) {
        try {
          rutas = JSON.parse(localStorage.getItem(this.localDBNameRutas));
        } catch (e) {
          console.log(e);
          localStorage.removeItem(this.localDBNameRutas);
        }
      }
      this.rutas = rutas;
      // return rutas;
    },
    viewRuta(item) {
      if (this.trackingPosition || this.pausedPosition) {
        this.newRuta = {};
        this.seconds = 0;
        window.clearInterval(this.coordsInterval);
        window.clearInterval(this.timerInterval);
        this.trackingPosition = false;
        this.pausedPosition = false;
      }
      this.geojson.geometry.coordinates = [];
      this.geojson.geometry.coordinates = item.coords;
      this.map.getSource("route").setData(this.geojson);
      this.itemShow = item;
      this.showingRuta = true;
      this.dialogViewRuta = false;
    },
    btnStopRecord() {
      let self = this;
      if (self.itemShow.id) {
        self.itemShow = {};
        this.geojson.geometry.coordinates = [];
        this.map.getSource("route").setData(this.geojson);
      }
      if (!self.trackingPosition && !self.pausedPosition) return;
      self.trackingPosition = false;
      self.pausedPosition = true;
      window.clearInterval(self.coordsInterval);
      window.clearInterval(self.timerInterval);
      self.dialogSaveRecord = true;
    },
    saveRecord() {
      let obj = {
        id: uuidv4(),
        name: this.rutaNombre,
        coords: JSON.parse(JSON.stringify(this.geojson.geometry.coordinates)),
        seconds: this.seconds,
        ...this.newRuta,
      };
      this.postUpdateLocalStorageDBRutas(obj);
      this.rutaNombre = "";
      this.geojson.geometry.coordinates = [];
      this.map.getSource("route").setData(this.geojson);
      this.newRuta = {};
      this.seconds = 0;
      this.listLocalStorageDBRutas();
      this.pausedPosition = false;
      this.dialogSaveRecord = false;
    },
    btnStartRecord() {
      let self = this;
      if (self.pausedPosition) {
        self.startRecord();
        return;
      }
      if (self.trackingPosition) {
        window.clearInterval(self.coordsInterval);
        window.clearInterval(self.timerInterval);
        self.trackingPosition = false;
        self.pausedPosition = true;
        return;
      }
      self.dialogStartRecord = true;
    },
    startRecord() {
      let self = this;
      self.pausedPosition = false;
      self.trackingPosition = true;
      if (self.showingRuta) {
        self.rutaNombre = "";
        self.geojson.geometry.coordinates = [];
        self.map.getSource("route").setData(self.geojson);
        self.showingRuta = false;
      }
      self.timerInterval = setInterval(async () => {
        self.seconds = self.seconds + 1;
      }, 1000);
      self.coordsInterval = setInterval(async () => {
        navigator.geolocation.getCurrentPosition(
          (position) => {
            setGeoJson(position);
            setCurrentPosition(position);
          },
          self.failurePosition,
          {
            enableHighAccuracy: true,
          }
        );
      }, 2000);
      const setGeoJson = (position) => {
        let _position = [position.coords.longitude, position.coords.latitude];
        self.geojson.geometry.coordinates.push(_position);
        self.map.getSource("route").setData(self.geojson);
      };

      const setCurrentPosition = (position) => {
        self.currentPositionMarker.setLngLat([
          position.coords.longitude,
          position.coords.latitude,
        ]);
      };
      self.dialogStartRecord = false;
    },
    postUpdateLocalStorageDBRutas(item) {
      let rutas = [];
      if (localStorage.getItem(this.localDBNameRutas)) {
        try {
          rutas = JSON.parse(localStorage.getItem(this.localDBNameRutas));
          let findItem = rutas.find((_x) => _x.id === item.id);
          if (findItem) {
            findItem = item;
          } else {
            rutas.push(item);
          }
        } catch (e) {
          console.log(e);
          localStorage.removeItem(this.localDBNameRutas);
          rutas = [item];
        }
      }
      localStorage.setItem(this.localDBNameRutas, JSON.stringify(rutas));
    },
    deleteItemLocalStorageDBRutas(item) {
      let rutas = [];
      if (this.itemShow.id && this.itemShow.id === item.id) {
        this.itemShow = {};
        this.geojson.geometry.coordinates = [];
        this.map.getSource("route").setData(this.geojson);
      }
      if (localStorage.getItem(this.localDBNameRutas)) {
        try {
          rutas = JSON.parse(localStorage.getItem(this.localDBNameRutas));
          rutas = rutas.filter((_x) => _x.id !== item.id);
        } catch (e) {
          console.log(e);
          localStorage.removeItem(this.localDBNameRutas);
          rutas = [item];
        }
      }
      localStorage.setItem(this.localDBNameRutas, JSON.stringify(rutas));
      if (rutas.length === 0) this.dialogViewRuta = false;
      this.listLocalStorageDBRutas();
    },
    initMap(position) {
      let self = this;
      self.centerPosition = {
        lat: position.coords.latitude,
        lng: position.coords.longitude,
      };
      mapboxgl.accessToken = self.accessToken;
      self.map = new mapboxgl.Map({
        container: "map", // container ID
        style: "mapbox://styles/mapbox/streets-v11", // style URL
        center: [position.coords.longitude, position.coords.latitude], // [lng, lat]
        zoom: 16, // starting zoom
      });
      // Marcador posicion actual
      let currentPositionMarker = new mapboxgl.Marker()
        .setLngLat([position.coords.longitude, position.coords.latitude])
        .addTo(self.map);
      self.currentPositionMarker = currentPositionMarker;
      let geojson = self.geojson;
      self.map.on("load", () => {
        self.map.addSource("route", {
          type: "geojson",
          data: geojson,
        });
        self.map.addLayer({
          id: "route",
          type: "line",
          source: "route",
          layout: {
            "line-join": "round",
            "line-cap": "round",
          },
          paint: {
            "line-color": "red",
            "line-width": 5,
          },
        });

        self.$refs.btnStartTracking.addEventListener("click", function () {
          self.btnStartRecord();
        });

        self.$refs.btnStopTracking.addEventListener("click", function () {
          self.btnStopRecord();
        });
      });
      self.mapObject = self.map;
    },
    failurePosition: function (err) {
      alert("Error Code: " + err.code + " Error Message: " + err.message);
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
#map-cont {
  width: 100%;
  height: 500px;
}

#map {
  width: 100%;
  height: 100%;
}
</style>
